#!/usr/bin/perl -w

use Test::More 'no_plan';

package Catch;

sub TIEHANDLE {
    my($class, $var) = @_;
    return bless { var => $var }, $class;
}

sub PRINT  {
    my($self) = shift;
    ${'main::'.$self->{var}} .= join '', @_;
}

sub READ {}
sub READLINE {}
sub GETC {}

my $Original_File = 'root/etc/e-smith/events/console-save/S80sshd-reload';

package main;

# pre-5.8.0's warns aren't caught by a tied STDERR.
$SIG{__WARN__} = sub { $main::_STDERR_ .= join '', @_; };
tie *STDOUT, 'Catch', '_STDOUT_' or die $!;
tie *STDERR, 'Catch', '_STDERR_' or die $!;

{
    undef $main::_STDOUT_;
    undef $main::_STDERR_;
#line 57 root/etc/e-smith/events/console-save/S80sshd-reload

system( $^X, $Original_File );
is( $?, 0,  'ran myself ok' );
sleep 1;
my $last_touch = -M "/var/lock/subsys/sshd";
cmp_ok( $last_touch, '<', 0, 'sshd lockfile touched' );


# Test stopping the sshd using fake tests.
$ENV{ESMITH_CONFIG_DB} = 'e-smith-openssh/stop.conf';

# this will run 9 tests.
my $tb = Test::More->builder;
$tb->current_test($tb->current_test + 9);

system( $^X, '-Ie-smith-openssh/lib', '-Mreload_overrides', $Original_File );
is( $?, 0,  'ran myself ok' );


# Test when there's no status.
$ENV{ESMITH_CONFIG_DB} = 'e-smith-openssh/nostatus.conf';
system( $^X, $Original_File );
is( $?, 0,  'ran myself ok' );
cmp_ok( -M "/var/lock/subsys/sshd", '==', $last_touch, 
                                 'sshd lockfile untouched' );


    undef $main::_STDOUT_;
    undef $main::_STDERR_;
}

