#!/usr/bin/perl -w

use Test::More 'no_plan';

package Catch;

sub TIEHANDLE {
    my($class, $var) = @_;
    return bless { var => $var }, $class;
}

sub PRINT  {
    my($self) = shift;
    ${'main::'.$self->{var}} .= join '', @_;
}

sub READ {}
sub READLINE {}
sub GETC {}

my $Original_File = 'root/etc/e-smith/events/actions/sshd-conf';

package main;

# pre-5.8.0's warns aren't caught by a tied STDERR.
$SIG{__WARN__} = sub { $main::_STDERR_ .= join '', @_; };
tie *STDOUT, 'Catch', '_STDOUT_' or die $!;
tie *STDERR, 'Catch', '_STDERR_' or die $!;

{
    undef $main::_STDOUT_;
    undef $main::_STDERR_;
#line 60 root/etc/e-smith/events/actions/sshd-conf

use esmith::ConfigDB;

SKIP: {
    my $db;

    skip "You have to be able to read the config DB to test this", 4
      unless $db = esmith::ConfigDB->open;

    $Destruct_Ok = $db->get('testing')->prop('destruction');

    SKIP: {
        skip "sshd reconfiguration would be destructive", 7 
          unless $Destruct_Ok;

        # Call ourself.
        system $^X, $Original_File;
        is( $@, '', 'ran myself ok' );

        sleep 1;

        foreach my $file (qw(/etc/ssh/sshd_config
                             /etc/ssh/ssh_host_key
                             /root/.ssh/config) )
        {
            cmp_ok( -M $file, '<', 0, "$file rewritten" );
            cmp_ok( -s $file, '>', 0, "$file is not empty" );
        }
    }
}


    undef $main::_STDOUT_;
    undef $main::_STDERR_;
}

